
Bar
	parent_type = /Control/
	ctype="bar"
	var
		width="10"
		dir="east"
		angle1="0"
		angle2="0"
		bar_color="none"
		is_slider="false"
		value="0"
		on_change=""
	GetParams()
		var/list/params = GetDefaultParams()
		params["width"]=width
		params["dir"]=dir
		params["angle1"]=angle1
		params["angle2"]=angle2
		params["bar-color"]=bar_color
		params["is-slider"]=is_slider
		params["value"]=value
		params["on_change"]=on_change
		return params
	proc
		setWidth(var/intWidth=0)
			if(!isnum(intWidth))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setWidth(intWidth)"
				world << "intWidth must be an integer."
				return
			width = intWidth
			if(AutoUpdate) winset(user, GPCN(), "width=[width]")
		setDir(var/newDir="east")
			if(!(newDir in list("north", "south", "east", "west", "clockwise", "counterclockwise")))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setDir(newDir)"
				world << "newDir must be one of:"
				world << "\"north\", \"south\", \"east\", \"west\", \"clockwise\", \"counterclockwise\""
				return
			dir = newDir
			if(AutoUpdate) winset(user, GPCN(), "dir=[dir]")
		setAngle1(var/intAngle=0)
			if(!isnum(intAngle))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setAngle1(intAngle)"
				world << "intAngle must be an integer."
				return
			angle1 = intAngle
			if(AutoUpdate) winset(user, GPCN(), "angle1=[angle1]")
		setAngle2(var/intAngle=0)
			if(!isnum(intAngle))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setAngle2(intAngle)"
				world << "intAngle must be an integer."
				return
			angle2 = intAngle
			if(AutoUpdate) winset(user, GPCN(), "angle2=[angle2]")
		setBarColor(var/NewColor)
			if(!isRGB(NewColor))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setBarColor(NewColor)"
				world << "NewColor must be an #RGB or #RRGGBB value."
				return
			bar_color = NewColor
			if(AutoUpdate) winset(user, GPCN(), "bar-color=[text_color]")
		setIsSlider(var/boolSlider="false")
			var/ipt = boolSlider
			if(!(ipt in list("true", "false")))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setIsSlider(boolSlider)"
				world << "boolSlider must be \"true\" or \"false\""
				return
			is_slider = ipt
			if(AutoUpdate) winset(user, GPCN(), "is-slider=[ipt]")
		setValue(var/intValue=0)
			if(!isnum(intValue))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setValue(intValue)"
				world << "intValue must be an integer."
				return
			if(intValue > 100 || intValue < 0)
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setValue(intValue)"
				world << "intValue must be between 0 and 100."
				return
			value = intValue
			if(AutoUpdate) winset(user, GPCN(), "value=[value]")
		setOnChange(var/newOnChange="")
			on_change = newOnChange
			if(AutoUpdate) winset(user, GPCN(), "on-change=\"[newOnChange]\"")