Button
	parent_type = /Control/
	ctype="button"
	var
		is_flat="false"
		is_checked="false"
		group=""
		button_type="pushbutton"
		text=""
		image=""
		command=""
	GetParams()
		var/list/params = GetDefaultParams()
		params["is-flat"] = is_flat
		params["is-checked"] = is_checked
		params["group"] = group
		params["button-type"] = button_type
		params["text"] = text
		params["image"] = image
		params["command"] = command
		return params
	proc
		setIsFlat(var/newIsFlat)
			var/ipt = newIsFlat
			if(!(ipt in list("true", "false")))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setIsFlat(newIsFlat)"
				world << "newIsFlat must be \"true\" or \"false\""
				return
			is_flat = ipt
			if(AutoUpdate) winset(user, GPCN(), "is-flat=[ipt]")
		setIsChecked(var/newIsChecked)
			var/ipt = newIsChecked
			if(!(ipt in list("true", "false")))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setIsChecked(newIsChecked)"
				world << "newIsChecked must be \"true\" or \"false\""
				return
			is_flat = ipt
			if(AutoUpdate) winset(user, GPCN(), "is-checked=[ipt]")
		setGroup(var/newGroup)
			group = newGroup
			if(AutoUpdate) winset(user, GPCN(), "group=\"[newGroup]\"")
		setButtonType(var/NewButtonType="pushbutton")
			var/nbt = lowertext(NewButtonType)
			if(!(nbt in list("pushbutton", "pushbox", "checkbox", "radio")))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setImageMode(NewImageMode)"
				world << "NewImageMode must be \"pushbutton\", \"pushbox\", \"checkbox\", \"radio\"."
				return
			button_type = nbt
			if(AutoUpdate) winset(user, GPCN(), "button-type=[nbt]")
		setText(var/newText)
			text = newText
			if(AutoUpdate) winset(user, GPCN(), "text=\"[newText]\"")
		setImage(var/newImage)
			if(!isicon(newImage))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setImage(newImage)"
				world << "newImage must be an icon / image."
				return
			image = newImage
			if(AutoUpdate) winset(user, GPCN(), "icon=[image]")
		setCommand(var/newCmd)
			command = newCmd
			if(AutoUpdate) winset(user, GPCN(), "command=\"[newCmd]\"")