Control
	var/name = ""
	var/Control/parentobj
	var/client/user
	var/AutoUpdate=1
	New(var/client/user, var/name, var/parent)
		if(user==null)
			world << "<FONT COLOR='#CC0000'>DIL: Major Error</FONT>"
			world << "------ [copytext("[src.type]",2)].New(User, Name, Parent)"
			world << "------ <FONT COLOR='#0000FF'>User Not specified."
			world << "------ File: [__FILE__] Line: [__LINE__]"
		else src.user = user
		if(name==null)
			world << "<FONT COLOR='#CC0000'>DIL: Major Error</FONT>"
			world << "------ [copytext("[src.type]",2)].New(User, Name, Parent)"
			world << "------ <FONT COLOR='#0000FF'>Name not specified."
			world << "------ File: [__FILE__] Line: [__LINE__]"
		else src.name = name
		if(parent==null)
			world << "<FONT COLOR='#CC0000'>DIL: Major Error</FONT>"
			world << "------ [copytext("[src.type]",2)].New(User, Name, Parent)"
			world << "------ <FONT COLOR='#0000FF'>Parent not specified."
			world << "------ File: [__FILE__] Line: [__LINE__]"
		else src.parent = parent
	var
		isControl=1                 //Is control boolean, as opposed to a window.
		ctype="control"             //Type of control, set individually per control. Constant value
		preexisting=0               //Preexisting, used for preexistant interface controls
		anchor1="none"              //First Anchor, defaulting to none
		anchor2="none"              //Second Anchor, defaulting to none
		is_visible="true"           //visibility of the control.
		is_transparent="false"      //transparancy of the control
		border="none"               //border of the control
		flash="0"                   //flash of the control. Unknown usage.
		text_color="#000000"        //text color for the control
		background_color="#F0F0F0"  //control's background color.
		is_default="false"          //if the control is the default control of that type.
		is_disabled="false"         //if the control is disabled (greyed out) or not
		focus="false"               //if the control having the client's focus
		drop_zone="false"           //if you can drag and drop items here
		right_click=""              //command on right click
		font_family=""              //font for the control
		font_size="0"               //size of the control's font
		font_style=""               //style of the control's font
		on_size=""                  //command activated by rezising the control
		parent=""                   //parent of the control
		x=0                         //X value of the control
		y=0                         //Y value of the control
		w=0                         //Width value of the control
		h=0                         //Height value of the control
	proc/GetDefaultParams()
		var/list/params = new
		params["type"]=ctype
		params["parent"]=parent
		params["pos"]="[x],[y]"
		params["size"]="[w]x[h]"
		params["anchor1"]=anchor1
		params["anchor2"]=anchor2
		params["is-visible"]=is_visible
		params["is-transparent"]=is_transparent
		params["border"]=border
		params["flash"]=flash
		params["text-color"]=text_color
		params["background-color"]=background_color
		params["is-default"]=is_default
		params["is-disabled"]=is_disabled
		params["focus"]=focus
		params["drop-zone"]=drop_zone
		params["right-click"]=right_click
		params["font-family"]=font_family
		params["font-size"]=font_size
		params["font-style"]=font_style
		params["on-size"]=on_size
		return params
	proc/GetParams()
		var/list/params = GetDefaultParams()
		return params
	proc/Update()
		var/list/params = GetParams()
		winset(user, GPCN(), list2params(params))
	proc/Hide()
		winset(user, GPCN(), "is-visible=false")
	proc/Show()
		winset(user, GPCN(), "is-visible=true")
	proc/Remove()
		winset(user, GPCN(), "parent=none")
	proc/GetExistingParams(var/client/user, var/controlID)
		//Dummy proc, will complete later.
	proc/GPCN()
		return "[parent].[name]"
	//Updating Procs to be added here.
	proc/IsDefaultValue(var/Control/c, var/paran)
		var/retv = 0
		var/Control/c2 = new(c.user, "temp", "window")
		if(c.vars[paran] == c2.vars[paran]) retv = 1
		else retv = 0
		del(c2)
		return retv

	proc
		setAU(var/NAU)
			if(NAU=="" || NAU=="false" || NAU=="0" || NAU==0) AutoUpdate=0
			else AutoUpdate=1
		getPos()
			return "[x],[y]"
		setPos(var/nx, var/ny)
			var/ERR
			if(!isnum(nx))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setPos(NewX, NewY)"
				world << "NewX must be numerical."
				ERR=1
			if(!isnum(ny))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setPos(NewX, NewY)"
				world << "NewY must be numerical."
				ERR=1
			if(!ERR)
				x=nx
				y=ny
				if(AutoUpdate) winset(user, GPCN(), "pos=[x],[y]")
		getX()
			return x
		getTrueX()
			return text2num(copytext(winget(user, "[name]", "pos"),1,findtext(winget(user, "[name]", "pos"),",")))
		updateX()
			setX(text2num(copytext(winget(user, "[name]", "pos"),1,findtext(winget(user, "[name]", "pos"),","))))
		setX(var/nx)
			if(!isnum(nx))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setX(NewX)"
				world << "NewX must be numerical."
				return
			x=nx
			if(AutoUpdate) winset(user, GPCN(), "pos=[x],[y]")
		getY()
			return y
		setY(var/ny)
			if(!isnum(ny))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setY(NewY)"
				world << "NewY must be numerical."
				return
			y=ny
			if(AutoUpdate) winset(user, GPCN(), "pos=[x],[y]")
		getSize()
			return "[w]x[h]"
		setSize(var/nw, var/nh)
			var/ERR
			if(!isnum(nw))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setSize(NewW, NewH)"
				world << "NewW must be numerical."
				ERR=1
			if(!isnum(nh))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setSize(NewW, NewH)"
				world << "NewH must be numerical."
				ERR=1
			if(!ERR)
				w=nw
				h=nh
				if(AutoUpdate) winset(user, GPCN(), "size=[w]x[h]")
		getW()
			return w
		setW(var/nw)
			if(!isnum(nw))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setW(NewW)"
				world << "NewW must be numerical."
				return
			w=nw
			if(AutoUpdate) winset(user, GPCN(), "size=[w]x[h]")
		getH()
			return h
		setH(var/nh)
			if(!isnum(nh))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setH(NewH)"
				world << "NewH must be numerical."
				return
			h=nh
			if(AutoUpdate) winset(user, GPCN(), "size=[w]x[h]")
		setBounds(var/nx, var/ny, var/nw, var/nh)
			var/ERR
			if(!isnum(nx))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setBounds(NewX, NewY, NewW, NewH)"
				world << "NewX must be numerical."
				ERR=1
			if(!isnum(ny))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setBounds(NewX, NewY, NewW, NewH)"
				world << "NewY must be numerical."
				ERR=1
			if(!isnum(nw))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setBounds(NewX, NewY, NewW, NewH)"
				world << "NewW must be numerical."
				ERR=1
			if(!isnum(nh))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setBounds(NewX, NewY, NewW, NewH)"
				world << "NewH must be numerical."
				ERR=1
			if(!ERR)
				x=nx
				y=ny
				w=nw
				h=nh
				if(AutoUpdate)
					winset(user, GPCN(), "pos=[x],[y]")
					winset(user, GPCN(), "size=[w]x[h]")
		//TODO: Anchors
		getVisible()
			return is_visible
		setVisible(var/NewVisibility="true")
			if(NewVisibility != "true" && NewVisibility != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setVisible(NewVisibility)"
				world << "NewVisibility must be \"true\" or \"false\""
				return
			is_visible=NewVisibility
			if(AutoUpdate) winset(user, GPCN(), "is-visible=[is_visible]")
		getTransparent()
			return is_transparent
		setTransparent(var/NewTransparency="true")
			if(NewTransparency != "true" && NewTransparency != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setTransparent(NewTransparency)"
				world << "NewTransparency must be \"true\" or \"false\""
				return
			is_transparent = NewTransparency
			if(AutoUpdate) winset(user, GPCN(), "is-transparent=[is_transparent]")
		getBorder()
			return border
		setBorder(var/B="none")
			var/BOARD = lowertext(B)
			if(BOARD == "sunken")
				border = "sunken"
			else if(BOARD == "line")
				border = "line"
			else if(BOARD == "" || BOARD == "none")
				border = "none"
			else
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setBoarder(NewBorder)"
				world << "NewBoarder must be \"line\", \"sunken\" or \"none\"."
				return
			if(AutoUpdate) winset(user, GPCN(), "border=[border]")
		getTextColor()
			return text_color
		setTextColor(var/NewColor)
			if(!isRGB(NewColor))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setTextColor(NewColor)"
				world << "NewColor must be an #RGB or #RRGGBB value."
				return
			text_color = NewColor
			if(AutoUpdate) winset(user, GPCN(), "text-color=[text_color]")
		getBackgroundColor()
			return background_color
		setBackgroundColor(var/NewColor)
			if(!isRGB(NewColor))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setBackgroundColor(NewColor)"
				world << "NewColor must be an #RGB or #RRGGBB value."
				return
			background_color = NewColor
			if(AutoUpdate) winset(user, GPCN(), "background-color=[background_color]")
		getIsDefault()
			return is_default
		setIsDefault(var/NewDefault)
			if(NewDefault != "true" && NewDefault != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setDefault(NewDefault)"
				world << "NewDefault must be \"true\" or \"false\""
				return
			is_default = NewDefault
			if(AutoUpdate) winset(user, GPCN(), "is-default=[is_default]")
		getIsDisabled()
			return is_disabled
		setIsDisabled(var/NewDisabled)
			if(NewDisabled != "true" && NewDisabled != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setDisabled(NewDisabled)"
				world << "NewDefault must be \"true\" or \"false\""
				return
			is_disabled = NewDisabled
			if(AutoUpdate) winset(user, GPCN(), "is-disabled=[is_disabled]")
		getFocus()
			return focus
		setFocus(var/NewFocus)
			if(NewFocus != "true" && NewFocus != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setFocus(NewFocus)"
				world << "NewFocus must be \"true\" or \"false\""
				return
			focus = NewFocus
			if(AutoUpdate) winset(user, GPCN(), "focus=[focus]")
		getDropZone()
			return drop_zone
		setDropZone(var/NewDropZone)
			if(NewDropZone != "true" && NewDropZone != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setDropZone(NewDropZone)"
				world << "NewDropZone must be \"true\" or \"false\""
				return
			drop_zone = NewDropZone
			if(AutoUpdate) winset(user, GPCN(), "drop-zone=[drop_zone]")
		getRightClick()
			return right_click
		setRightClick(var/NewRightClick)
			if(NewRightClick != "true" && NewRightClick != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setRightClick(NewRightClick)"
				world << "NewRightClick must be \"true\" or \"false\""
				return
			right_click = NewRightClick
			if(AutoUpdate) winset(user, GPCN(), "right-click=[right_click]")
		getFontFamily()
			return font_family
		setFontFamily(var/NewFontFamily)
			font_family = NewFontFamily
			if(AutoUpdate) winset(user, GPCN(), "font-family=[font_family]")
		getFontSize()
			return font_size
		setFontSize(var/NewFontSize)
			if(!isnum(NewFontSize))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setFontSize(NewFontSize)"
				world << "NewFontSize must be numerical."
				return
			font_size=NewFontSize
			if(AutoUpdate) winset(user, GPCN(), "font-size=[font_size]")
		getFontStyle()
			return font_style
		setFontStyle(var/NewFontStyle)
			font_style = NewFontStyle
			if(AutoUpdate) winset(user, GPCN(), "font-style=[font_style]")
		getOnSize()
			return on_size
		setOnSize(var/NewOnSize)
			on_size = NewOnSize
			if(AutoUpdate) winset(user, GPCN(), "on-size=[on_size]")