Grid
	parent_type = /Control/
	ctype="grid"
	background_color = "#FFFFFF"
	var
		cells="0x0"
		cell_span="1x1"
		is_list="false"
		show_lines="both"
		style=""
		line_color="#C0C0C0"
		link_color="#0FF"
		visited_color="#F0F"
		current_cell="0x0"
		show_names="true"
		small_icons="false"
		enable_http_images="false"
	GetParams()
		var/list/params = GetDefaultParams()
		params["cells"]=cells
		params["cell-span"]=cell_span
		params["is-list"]=is_list
		params["show-lines"]=show_lines
		params["style"]=style
		params["line-color"]=line_color
		params["link-color"]=link_color
		params["visited-color"]=visited_color
		params["current-cell"]=current_cell
		params["show-names"]=show_names
		params["small-icons"]=small_icons
		params["enable-http-images"]=enable_http_images
		return params
	proc
		setCells(var/NewCells)
			if(!findtext(NewCells, "x"))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setCells(NewCells)"
				world << "NewCells must be in the format: \"#x#\""
				return
			cells = NewCells
			if(AutoUpdate) winset(user, GPCN(), "cells=[cells]")
		setCellSpan(var/NewCellspan)
			if(!findtext(NewCellspan, "x"))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setCellSpan(NewCellspan)"
				world << "NewCellspan must be in the format: \"#x#\""
				return
			cell_span = NewCellspan
			if(AutoUpdate) winset(user, GPCN(), "cell-span=[cell_span]")
		setIsList(var/boolIsList="false")
			if(!(boolIsList in list("true", "false")))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setIsList(boolIsList)"
				world << "boolIsList must be \"true\" or \"false\""
				return
			is_list=boolIsList
			if(AutoUpdate) winset(user, GPCN(), "is-list=[boolIsList]")
		setShowLines(var/newShowLines="both")
			if(!(newShowLines in list("none", "both", "vertical", "horizontal")))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setIsList(boolIsList)"
				world << "boolIsList must be one of these:"
				world << "\"none\", \"horizontal\", \"vertical\", \"both\""
				return
			show_lines=newShowLines
			if(AutoUpdate) winset(user, GPCN(), "show-lines=[show_lines]")
		setStyle(var/newStyle="")
			style = newStyle
			if(AutoUpdate) winset(user, GPCN(), "style=\"[style]\"")
		setLineColor(var/NewColor)
			if(!isRGB(NewColor))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setLineColor(NewColor)"
				world << "NewColor must be an #RGB or #RRGGBB value."
				return
			line_color = NewColor
			if(AutoUpdate) winset(user, GPCN(), "line-color=[line_color]")
		setLinkColor(var/NewColor)
			if(!isRGB(NewColor))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setLinkColor(NewColor)"
				world << "NewColor must be an #RGB or #RRGGBB value."
				return
			link_color = NewColor
			if(AutoUpdate) winset(user, GPCN(), "link-color=[link_color]")
		setVisitedColor(var/NewColor)
			if(!isRGB(NewColor))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setVisitedColor(NewColor)"
				world << "NewColor must be an #RGB or #RRGGBB value."
				return
			visited_color = NewColor
			if(AutoUpdate) winset(user, GPCN(), "visited-color=[link_color]")
		setCurrentCell(var/newCurrentCell)
			if(!findtext(newCurrentCell, "x"))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setCurrentCell(newCurrentCell)"
				world << "newCurrentCell must be in the format: \"#x#\""
				return
			current_cell = newCurrentCell
			if(AutoUpdate) winset(user, GPCN(), "current-cell=[cell_span]")
		swtShowNames(var/boolShowName="false")
			if(!(boolShowName in list("true", "false")))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].swtShowNames(boolShowName)"
				world << "boolShowName must be \"true\" or \"false\""
				return
			show_names=boolShowName
			if(AutoUpdate) winset(user, GPCN(), "show-names=[show_names]")
		setSmallIcons(var/boolSmallIcons="false")
			if(!(boolSmallIcons in list("true", "false")))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setSmallIcons(boolSmallIcons)"
				world << "boolSmallIcons must be \"true\" or \"false\""
				return
			small_icons=boolSmallIcons
			if(AutoUpdate) winset(user, GPCN(), "small-icons=[boolSmallIcons]")
		setEnableHttpImages(var/newEHI)
			var/ipt = newEHI
			if(!(ipt in list("true", "false")))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setEnableHttpImages(newEHI)"
				world << "newEHI must be \"true\" or \"false\""
				return
			enable_http_images = ipt
			if(AutoUpdate) winset(user, GPCN(), "enable-http-images=[ipt]")