Info
	parent_type = /Control/
	ctype="info"
	var
		multi_line="true"
		highlight_color="#00FF00"
		tab_text_color="none"
		tab_background_color="none"
		allow_html="false"
		tab_font_family=""
		tab_font_size="0"
		tab_font_style=""
		on_show=""
		on_hide=""
		on_tab=""
	GetParams()
		var/list/params = GetDefaultParams()
		params["multi-line"]=multi_line
		params["highlight-color"]=highlight_color
		params["tab-text-color"]=tab_text_color
		params["tab-background-color"]=tab_background_color
		params["allow-html"]=allow_html
		params["tab-font-family"]=tab_font_family
		params["tab-font-size"]=tab_font_size
		params["tab-font-style"]=tab_font_style

		params["on-show"]=on_show
		params["on-hide"]=on_hide
		params["on-tab"]=on_tab
		return params
	proc
		setMultiLine(var/newMultiLine="true")
			var/ipt = lowertext(newMultiLine)
			if(!(ipt in list("true", "false")))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setMultiLine(newMultiLine)"
				world << "newMultiLine must be \"true\" or \"false\""
				return
			multi_line = ipt
			if(AutoUpdate) winset(user, GPCN(), "multi-line=[ipt]")
		setHighlightColor(var/NewColor="#00FF00")
			if(!isRGB(NewColor))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setHighlightColor(NewColor)"
				world << "NewColor must be an #RGB or #RRGGBB value."
				return
			highlight_color = NewColor
			if(AutoUpdate) winset(user, GPCN(), "highlight-color=[NewColor]")
		setTabTextColor(var/NewColor="#00FF00")
			if(!isRGB(NewColor))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setTabTextColor(NewColor)"
				world << "NewColor must be an #RGB or #RRGGBB value."
				return
			tab_text_color = NewColor
			if(AutoUpdate) winset(user, GPCN(), "tab-text-color=[NewColor]")
		setTabBackgroundColor(var/NewColor="#00FF00")
			if(!isRGB(NewColor))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setTabBackgroundColor(NewColor)"
				world << "NewColor must be an #RGB or #RRGGBB value."
				return
			tab_background_color = NewColor
			if(AutoUpdate) winset(user, GPCN(), "tab-background-color=[NewColor]")
		setAllowHTML(var/boolAllowHTML="true")
			if(!(boolAllowHTML in list("true", "false")))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setAllowHTML(boolAllowHTML)"
				world << "boolAllowHTML must be \"true\" or \"false\""
				return
			allow_html = boolAllowHTML
			if(AutoUpdate) winset(user, GPCN(), "allow-html=[boolAllowHTML]")
		setTabFontFamily(var/NewFontFamily)
			tab_font_family = NewFontFamily
			if(AutoUpdate) winset(user, GPCN(), "tab-font-family=[font_family]")
		setTabFontSize(var/NewFontSize)
			if(!isnum(NewFontSize))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setTabFontSize(NewFontSize)"
				world << "NewFontSize must be numerical."
				return
			tab_font_size=NewFontSize
			if(AutoUpdate) winset(user, GPCN(), "tab-font-size=[font_size]")
		setTabFontStyle(var/NewFontStyle)
			tab_font_style = NewFontStyle
			if(AutoUpdate) winset(user, GPCN(), "tab-font-style=[font_style]")
		setOnShow(var/newOnShow="")
			on_show = newOnShow
			if(AutoUpdate) winset(user, GPCN(), "on-show=\"[on_show]\"")
		setOnHide(var/newOnHide="")
			on_hide = newOnHide
			if(AutoUpdate) winset(user, GPCN(), "on-hide=\"[on_hide]\"")
		setOnTab(var/newOnTab="")
			on_tab = newOnTab
			if(AutoUpdate) winset(user, GPCN(), "on-tab=\"[newOnTab]\"")