Label
	parent_type = /Control/
	ctype="label"
	var
		text=""
		align="center"
		text_wrap="false"
		image=""
		image_mode="stretch"
		keep_aspect="false"
		list/Alignments = list("left", "center", "right", "top",
                                 "bottom", "top-right", "top-left",
                                 "bottom-right", "bottom-left")
	GetParams()
		var/list/params = GetDefaultParams()
		params["text"]=text
		params["align"]=align
		params["text-wrap"]=text_wrap
		params["image"]=image
		params["image-mode"]=image_mode
		params["keep-aspect"]=keep_aspect
		return params
	proc
		setText(var/NewText)
			text=NewText
			if(AutoUpdate) winset(user, GPCN(), "text=[text]")
		setAlign(var/NewAlign="none")
			var/newalign = lowertext(NewAlign)
			if(!(newalign in Alignments))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setAlign(NewAlign)"
				world << "NewAlign must be one of the following:"
				world << "\"left\", \"center\", \"right\", \"top\", \"bottom\""
				world << "\"top-right\", \"top-left\", \"bottom-right\", \"bottom-left\""
				return
			align=newalign
			if(AutoUpdate) winset(user, GPCN(), "align=[align]")
		setTextWrap(var/NewTextWrap="true")
			if(NewTextWrap != "true" && NewTextWrap != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setTextWrap(NewTextWrap)"
				world << "NewTextWrap must be \"true\" or \"false\""
				return
			text_wrap = NewTextWrap
			if(AutoUpdate) winset(user, GPCN(), "text-wrap=[text_wrap]")
		setImage(var/NewImage)
			if(!isicon(NewImage))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setImage(NewImage)"
				world << "NewImage must be an icon."
				return
			image = NewImage
			if(AutoUpdate) winset(user, GPCN(), "image=[image]")
		setImageMode(var/NewImageMode="none")
			var/newimagemode = lowertext(NewImageMode)
			if(newimagemode == "center")
				image_mode = "center"
			else if(newimagemode == "tile")
				image_mode = "tile"
			else if(newimagemode == "stretch")
				image_mode = "stretch"
			else
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setImageMode(NewImageMode)"
				world << "NewImageMode must be \"center\", \"tile\" or \"stretch\"."
				return
			if(AutoUpdate) winset(user, GPCN(), "image-mode=[image_mode]")
		setKeepAspect(var/NewKeepAspect="true")
			if(NewKeepAspect != "true" && NewKeepAspect != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setKeepAspect(NewKeepAspect)"
				world << "NewKeepAspect must be \"true\" or \"false\""
				return
			keep_aspect = NewKeepAspect
			if(AutoUpdate) winset(user, GPCN(), "keep-aspect=[keep_aspect]")
