Window
	parent_type = /Control/
	isControl=0
	ctype="window"
	var/created=0
	var
		list/Control/Controls = new
		can_minimize="true"; can_resize="true"
		is_minimized="false"; is_maximized="false"
		alpha="255"; statusbar="false"
		transparent_color="none"; can_close="true"
		title=""; titlebar="true"; icon=""
		image=""; image_mode="stretch"
		keep_aspect="false"; macro=""; menu=""
		on_close=""; can_scroll="none"; is_pane="false"
	GetParams()
		var/list/params = GetDefaultParams()
		params["parent"]="window"
		params["can-minimize"]=can_minimize
		params["can-resize"]=can_resize
		params["is-maximized"]=is_maximized
		params["is-maximized"]=is_maximized
		params["alpha"]=alpha
		params["statusbar"]=statusbar
		params["transparent-color"]=transparent_color
		params["can-close"]=can_close
		params["title"]=title
		params["titlebar"]=titlebar
		params["icon"]=icon
		params["image"]=image
		params["image-mode"]=image_mode
		params["keep-aspect"]=keep_aspect
		params["macro"]=macro
		params["menu"]=menu
		params["on-close"]=on_close
		params["can-scroll"]=can_scroll
		params["is-pane"]=is_pane
		return params
	proc/Create()
		winclone(user,"window","[name]")
		winset(user,"[name]","is-visible=false")
		created=1
	Update()
		if(!created) Create()
		var/list/params = GetParams()
		winset(user, "[name]", list2params(params))
		for(var/Control/c in Controls)
			c.Update()
	Remove()
		for(var/Control/c in Controls)
			winset(user, c.name, "parent=none")
		winset(user, src.name, "parent=none")
	GPCN()
		return "[name]"
	proc
		setCanResize(var/NewResizable="true")
			if(NewResizable != "true" && NewResizable != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setCanResize(NewResizable)"
				world << "NewResizable must be \"true\" or \"false\""
				return
			can_resize = NewResizable
			if(AutoUpdate) winset(user, GPCN(), "can-resize=[can_resize]")
		setCanMinimize(var/NewMinimizable="true")
			if(NewMinimizable != "true" && NewMinimizable != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setCanMinimize(NewMinimizable)"
				world << "NewResizable must be \"true\" or \"false\""
				return
			can_minimize = NewMinimizable
			if(AutoUpdate) winset(user, GPCN(), "can-minimize=[can_minimize]")
		setIsMinimized(var/NewMinimized="true")
			if(NewMinimized != "true" && NewMinimized != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setIsMinimized(NewMinimized)"
				world << "NewMinimized must be \"true\" or \"false\""
				return
			is_minimized = NewMinimized
			if(AutoUpdate) winset(user, GPCN(), "is-minimized=[is_minimized]")
		setIsMaximized(var/NewMaximized="true")
			if(NewMaximized != "true" && NewMaximized != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setIsMaximized(NewMaximized)"
				world << "NewMaximized must be \"true\" or \"false\""
				return
			is_maximized = NewMaximized
			if(AutoUpdate) winset(user, GPCN(), "is-maximized=[NewMaximized]")
		setAlpha(var/NewAlpha)
			if(!isnum(NewAlpha))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setAlpha(NewAlpha)"
				world << "NewAlpha must be numerical."
				return
			if(NewAlpha > 255 || NewAlpha < 0)
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setAlpha(NewAlpha)"
				world << "NewAlpha must be between 0 and 255."
				return
			alpha = NewAlpha
			if(AutoUpdate) winset(user, GPCN(), "alpha=[alpha]")
		setStatusbar(var/NewStatusbar="true")
			if(NewStatusbar != "true" && NewStatusbar != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setStatusbar(NewStatusbar)"
				world << "NewStatusbar must be \"true\" or \"false\""
				return
			statusbar = NewStatusbar
			if(AutoUpdate) winset(user, GPCN(), "statusbar=[statusbar]")
		setTransparentColor(var/NewTransColor="#FFFF00")
			if(!isRGB(NewTransColor))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setTransparentColor(NewTransColor)"
				world << "NewTransColor must be an #RGB or #RRGGBB value."
				return
			transparent_color = NewTransColor
			if(AutoUpdate) winset(user, GPCN(), "transparent-color=[NewTransColor]")
		setTitle(var/NewTitle)
			title = NewTitle
			if(AutoUpdate) winset(user, GPCN(), "title=[title]")
		setTitlebar(var/NewTitlebar="true")
			if(NewTitlebar != "true" && NewTitlebar != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setTitlebar(NewTitlebar)"
				world << "NewTitlebar must be \"true\" or \"false\""
				return
			titlebar = NewTitlebar
			if(AutoUpdate) winset(user, GPCN(), "titlebar=[titlebar]")
		setIcon(var/NewIcon)
			if(!isicon(NewIcon))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setIcon(NewIcon)"
				world << "NewIcon must be an icon."
				return
			icon = NewIcon
			if(AutoUpdate) winset(user, GPCN(), "icon=[icon]")
		setImage(var/NewImage)
			if(!isicon(NewImage))
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setImage(NewImage)"
				world << "NewImage must be an icon."
				return
			image = NewImage
			if(AutoUpdate) winset(user, GPCN(), "image=[image]")
		setImageMode(var/NewImageMode="none")
			var/newimagemode = lowertext(NewImageMode)
			if(newimagemode == "center")
				image_mode = "center"
			else if(newimagemode == "tile")
				image_mode = "tile"
			else if(newimagemode == "stretch")
				image_mode = "stretch"
			else
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setImageMode(NewImageMode)"
				world << "NewImageMode must be \"center\", \"tile\" or \"stretch\"."
				return
			if(AutoUpdate) winset(user, GPCN(), "image-mode=[image_mode]")
		setKeepAspect(var/NewKeepAspect="true")
			if(NewKeepAspect != "true" && NewKeepAspect != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setKeepAspect(NewKeepAspect)"
				world << "NewKeepAspect must be \"true\" or \"false\""
				return
			keep_aspect = NewKeepAspect
			if(AutoUpdate) winset(user, GPCN(), "keep-aspect=[keep_aspect]")
		setMacro(var/NewMacro)
			macro = NewMacro
			if(AutoUpdate) winset(user, GPCN(), "macro=[macro]")
		setMenu(var/NewMenu)
			menu = NewMenu
			if(AutoUpdate) winset(user, GPCN(), "menu=[menu]")
		setOnClose(var/NewOnClose)
			on_close = NewOnClose
			if(AutoUpdate) winset(user, GPCN(), "on-close=[on_close]")
		setCanScroll(var/NewCanScroll="true")
			if(NewCanScroll != "true" && NewCanScroll != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setCanScroll(NewCanScroll)"
				world << "NewCanScroll must be \"true\" or \"false\""
				return
			can_scroll = NewCanScroll
			if(AutoUpdate) winset(user, GPCN(), "can-scroll=[can_scroll]")
		setIsPane(var/NewIsPane="true")
			if(NewIsPane != "true" && NewIsPane != "false")
				world << "DIL: Minor Error"
				world << "[copytext("[src.type]",2)].setIsPane(NewIsPane)"
				world << "NewIsPane must be \"true\" or \"false\""
				return
			is_pane = NewIsPane
			if(AutoUpdate) winset(user, GPCN(), "is-pane=[is_pane]")